
;=============================================
;                                            ;
; miniODE - a simple ODE wrapper for Blitz3D ;
;                                            ;
;=============================================


.lib "miniODE.dll"


; Global simulation functions
;=============================

ODE_CreateSimulation_() : "_ODE_CreateSimulation_@0"
ODE_FreeSimulation_() : "_ODE_FreeSimulation_@0"
ODE_SetGravity(gravX#, gravY#, gravZ#) : "_ODE_SetGravity@12"
ODE_SetGlobalParameters(settings*) : "_ODE_SetGlobalParameters@4"
ODE_GetGlobalParameters(settings*) : "_ODE_GetGlobalParameters@4"
ODE_UpdatePhysics(stepsize#) : "_ODE_UpdatePhysics@4"
;ODE_UpdateScene()


; Rigid body functions
;======================

;Creation and attributes
ODE_CreateBody_%(userdata*) : "_ODE_CreateBody_@4"
ODE_FreeBody_(body) : "_dBodyDestroy@4"
ODE_SetMode(body, mode) : "_ODE_SetMode@8"
ODE_GetMode%(body) : "_ODE_GetMode@4"
ODE_SetBodyMaterial_(body, mat*) : "_dBodySetData@8"
ODE_SetAutoDisable(body, ad*) : "_ODE_SetAutoDisable@8"
ODE_GetAutoDisable(body, ad*) : "_ODE_GetAutoDisable@8"
ODE_SetDamping(body, ds*) : "_ODE_SetDamping@8"
ODE_GetDamping(body, ds*) : "_ODE_GetDamping@8"
ODE_SetGravMode(body, mode) : "_dBodySetGravityMode@8"
ODE_GetGravMode%(body) : "_dBodyGetGravityMode@4"
ODE_SetMass(body, mass#) : "_ODE_SetMass@8"
ODE_GetMass#(body) : "_ODE_GetMass@4"
;ODE_SetEntity(ODEbody, B3Dentity)
;ODE_CountGeoms%(body)
;ODE_CountJoints%(body)
;ODE_GetGeom%(body, index)
;ODE_GetJoint%(body, index)

;Forces and movement
ODE_SetPosition(body, x#, y#, z#) : "_dBodySetPosition@16"
ODE_GetX#(body) : "_ODE_GetX@4"
ODE_GetY#(body) : "_ODE_GetY@4"
ODE_GetZ#(body) : "_ODE_GetZ@4"
ODE_SetRotation(body, pitch#, yaw#, roll#) : "_ODE_SetRotation@16"
;ODE_GetPitch#(body) : "_ODE_GetPitch@4"
;ODE_GetYaw#(body) : "_ODE_GetYaw@4"
;ODE_GetRoll#(body) : "_ODE_GetRoll@4"
ODE_GetRotation(obj, type, bank*) : "_ODE_GetRotation_@12"
ODE_ApplyForce(body, x#, y#, z#) : "_dBodyAddForce@16"
ODE_ApplyForceOffset(body, x#, y#, z#, ox#, oy#, oz#) : "_dBodyAddForceAtPos@28"
ODE_SetForce(body, x#, y#, z#) : "_dBodySetForce@16"
ODE_GetForceX#(body) : "_ODE_GetForceX@4"
ODE_GetForceY#(body) : "_ODE_GetForceY@4"
ODE_GetForceZ#(body) : "_ODE_GetForceZ@4"
ODE_ApplyTorque(body, pitch#, yaw#, roll#) : "_dBodyAddTorque@16"
ODE_SetTorque(body, pitch#, yaw#, roll#) : "_dBodySetTorque@16"
ODE_GetTorqueX#(body) : "_ODE_GetTorqueX@4"
ODE_GetTorqueY#(body) : "_ODE_GetTorqueY@4"
ODE_GetTorqueZ#(body) : "_ODE_GetTorqueZ@4"
ODE_GetLinearVelX#(body) : "_ODE_GetLinearVelX@4"
ODE_GetLinearVelY#(body) : "_ODE_GetLinearVelY@4"
ODE_GetLinearVelZ#(body) : "_ODE_GetLinearVelZ@4"
ODE_GetAngularVelX#(body) : "_ODE_GetAngularVelX@4"
ODE_GetAngularVelY#(body) : "_ODE_GetAngularVelY@4"
ODE_GetAngularVelZ#(body) : "_ODE_GetAngularVelZ@4"

;Geometry
ODE_AddSphere_%(body, radius#) : "_ODE_AddSphere_@8"
ODE_AddBox_%(body, sx#, sy#, sz#) : "_ODE_AddBox_@16"
ODE_AddCapsule_%(body, radius#, length#) : "_ODE_AddCapsule_@12"
ODE_AddCylinder_%(body, radius#, length#) : "_ODE_AddCylinder_@12"
ODE_AddTrimesh_%(body, vBank*, vCount, tBank*, tCount, nBank*) : "_ODE_AddTrimesh_@24"
ODE_FreeGeom_%(geom) : "_ODE_FreeGeom_@4"
ODE_SetGeomMaterial_(geom, mat*) : "_dGeomSetData@8"
ODE_PositionGeom(geom, px#, py#, pz#) : "_dGeomSetOffsetPosition@16"
ODE_RotateGeom(geom, pitch#, yaw#, roll#) : "_ODE_RotateGeom@16"
ODE_GeomX#(geom) : "_ODE_GeomX@4"
ODE_GeomY#(geom) : "_ODE_GeomY@4"
ODE_GeomZ#(geom) : "_ODE_GeomZ@4"
;ODE_GeomPitch#(geom) : "_ODE_GeomPitch@4"
;ODE_GeomYaw#(geom) : "_ODE_GeomYaw@4"
;ODE_GeomRoll#(geom) : "_ODE_GeomRoll@4"
ODE_GetClass%(geom) : "_dGeomGetClass@4"
ODE_EnableGeom(geom) : "_dGeomEnable@4"
ODE_DisableGeom(geom) : "_dGeomDisable@4"
ODE_GeomEnabled%(geom) : "_dGeomIsEnabled@4"


; Joint functions
;=================

ODE_CreateJoint_%(jointType, bodyA, bodyB) : "_ODE_CreateJoint_@12"
ODE_FreeJoint_(joint) : "_dJointDestroy@4"
ODE_EnableJoint(joint) : "_dJointEnable@4"
ODE_DisableJoint(joint) : "_dJointDisable@4"
ODE_JointEnabled%(joint) : "_dJointIsEnabled@4"
ODE_GetJointType%(joint) : "_dJointGetType@4"
ODE_GetJointBody%(joint, index) : "_dJointGetBody@8"
ODE_Connected%(bodyA, bodyB) : "_ODE_Connected@8"
ODE_PositionJoint(joint, px#, py#, pz#) : "_ODE_PositionJoint@16"
ODE_JointX#(joint) : "_ODE_JointX@4"
ODE_JointY#(joint) : "_ODE_JointY@4"
ODE_JointZ#(joint) : "_ODE_JointZ@4"
ODE_SetJointAxis(joint, px#, py#, pz#) : "_ODE_SetJointAxis@16"
ODE_JointAxisX#(joint) : "_ODE_JointAxisX@4"
ODE_JointAxisY#(joint) : "_ODE_JointAxisY@4"
ODE_JointAxisZ#(joint) : "_ODE_JointAxisZ@4"
ODE_LimitJoint(joint, max#, min#) : "_ODE_LimitJoint@12"
ODE_JointMax#(joint) : "_ODE_JointMax@4"
ODE_JointMin#(joint) : "_ODE_JointMin@4"